using System;
using System.Collections.Generic;
using System.Text;

namespace QiHe.RealMedia
{
    public class Record
    {
        public string Name;
        //public List<Field> Fields = new List<Field>();
        public Dictionary<string, object> Fields = new Dictionary<string, object>();

        public bool HasError;

        //public void AddField(Field field)
        //{
        //    Fields.Add(field.Name, field.Value);
        //}
        public byte[] Data;

        public object this[string fieldname]
        {
            get
            {
                if (Fields.ContainsKey(fieldname))
                {
                    return Fields[fieldname];
                }
                else
                {
                    return null;
                }
            }
            set
            {
                Fields[fieldname] = value;
            }
        }

        public void CopyFrom(Record record)
        {
            this.Name = record.Name;
            Fields.Clear();
            foreach (KeyValuePair<string, object> field in record.Fields)
            {
                this.Fields.Add(field.Key, field.Value);
            }
        }

        public override string ToString()
        {
            return Name + " Record";
        }
    }
}
