using System;
using System.Collections.Generic;
using System.Text;

namespace QiHe.RealMedia
{
    public partial class Process
    {
        public static MediaFile CutMedia(MediaFile media, int start, int end)
        {
            MediaFile portion = new MediaFile();
            uint duration = (uint)(end - start);
            Chunk prop = null;
            uint num_packets = 0;
            foreach (Chunk chunk in media.Chunks)
            {
                if (chunk.Name == "PROP")
                {
                    Chunk new_chunk = new Chunk();
                    new_chunk.CopyFrom(chunk);
                    SetDuration(duration, new_chunk);
                    portion.Chunks.Add(new_chunk);
                    prop = new_chunk;
                }
                else if (chunk.Name == "MDPR")
                {
                    Chunk new_chunk = new Chunk();
                    new_chunk.CopyFrom(chunk);
                    SetDuration(duration, new_chunk);
                    portion.Chunks.Add(new_chunk);
                }
                else if (chunk.Name == "DATA")
                {
                    Chunk new_chunk = new Chunk();
                    new_chunk.CopyFrom(chunk);
                    List<Record> new_packets = new List<Record>();
                    IEnumerable<Record> packets = (IEnumerable<Record>)chunk["packets"];
                    foreach (Record packet in packets)
                    {
                        uint timestamp = (uint)packet["timestamp"];
                        if (timestamp >= start && timestamp <= end)
                        {
                            Record new_packet = new Record();
                            new_packet.CopyFrom(packet);
                            new_packet["timestamp"] = (uint)(timestamp - start);
                            new_packets.Add(new_packet);
                        }
                    }
                    new_chunk["packets"] = new_packets;
                    new_chunk["num_packets"] = (uint)new_packets.Count;
                    num_packets += (uint)new_packets.Count;
                    portion.Chunks.Add(new_chunk);
                }
                else if (chunk.Name == "INDX")
                {
                }
                else
                {
                    portion.Chunks.Add(chunk);
                }
            }
            prop["num_packets"] = num_packets;
            return portion;
        }

        private static void SetDuration(uint duration, Chunk new_chunk)
        {
            if ((uint)new_chunk["duration"] > 0)
            {
                new_chunk["duration"] = duration;
            }
        }
    }
}
